include:
    # reprepro APT repository creation
    - "https://gitlab.com/nobodyinperson/ci-templates/raw/master/reprepro.yml"
    # publishing reprepro APT repository creation via GitLab Pages
    - "https://gitlab.com/nobodyinperson/ci-templates/raw/master/reprepro-pages.yml"

variables:
    DEBFULLNAME: $GITLAB_USER_NAME
    DEBEMAIL: $GITLAB_USER_EMAIL

stages:
    - package
    - test-package
    - pre-deploy
    - deploy

debian-package:
  image: debian
  stage: package
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  before_script:
    - apt-get -qq update >/dev/null 2>/dev/null
    - apt-get -qq -y build-dep . >/dev/null 2>/dev/null
    - apt-get -qq -y install devscripts dpkg-dev git >/dev/null 2>/dev/null
    - git fetch --tags
    - git log --oneline --graph --all --decorate
  script:
    - git_ver="`git describe --tags --always --match 'v*' | perl -pe 'chomp;s/^v//g;s/[^\w.]/+/gi'`";if ! test "`dpkg-parsechangelog --show-field Version`" = "$git_ver";then dch --newversion "$git_ver" "CI build on $git_ver";fi
    - dpkg-buildpackage
    - mv ../*.deb .
  artifacts:
    when: on_success
    expire_in: 1 week
    paths:
      - '*.deb'
lintian:
    variables:
        GIT_STRATEGY: none
    stage: test-package
    image: debian
    before_script:
        - "apt-get -qq update >/dev/null 2>/dev/null"
        - "apt-get -qq -y install lintian >/dev/null 2>/dev/null"
        - "package=\"`find -iname '*.deb' | tail -n1`\""
    script:
        - "lintian --allow-root \"$package\""
    dependencies:
        - debian-package
    allow_failure: true

install-remove:
    variables:
        GIT_STRATEGY: none
    stage: test-package
    image: debian
    before_script:
        - "apt-get -qq update >/dev/null 2>/dev/null"
        - "package=\"`find -iname '*.deb' `\""
        - "pkgname=\"`dpkg-deb -f \"$package\" Package`\""
    script:
        - "dpkg -i \"$package\" || apt-get -qq -y install -f"
        - "apt-get -qq -y remove \"$pkgname\""
        - "apt-get -qq -y purge \"$pkgname\""
    dependencies:
        - debian-package

reprepro:
    stage: pre-deploy
    dependencies:
        - debian-package
    needs:
        - debian-package

pages:
    stage: deploy
    environment:
        name: APT Repository on GitLab Pages
        url: $CI_PAGES_URL
    dependencies:
        - reprepro
    only:
        - master
